#include <Servo.h>

Servo myservoPUSHER;
Servo myservoSLIDER;

const int buttonMinutes = 4;
int buttonStateMinutes = 0;

int FiveMinuteCounter = 0;
int OneHourCounter = 0;

unsigned long time_now = 0;


void setup() 
{
  Serial.begin(9600);

  pinMode(buttonMinutes, INPUT);
  
  myservoPUSHER.attach(2); 
  myservoSLIDER.attach(3);
   
  myservoPUSHER.write(90);
  myservoSLIDER.write(90);
  delay(5000);  
  
  myservoPUSHER.detach();      
  myservoSLIDER.detach();   
}




void loop() 
{
  FiveMinuteCounter = ((millis()/1000) % (300)); // FiveMinuteCounter = 0 every 5 minutes
  

  buttonStateMinutes = digitalRead(buttonMinutes);

  Serial.print("  FiveMinuteCounter: ");
  Serial.print(FiveMinuteCounter);
  Serial.print("  OneHourCounter: ");
  Serial.print(OneHourCounter);
  Serial.print("  buttonStateMinutes: ");
  Serial.println(buttonStateMinutes);



// if button pressed move minute ball 5 minutes forward

  if (buttonStateMinutes == 1)
  {
     myservoPUSHER.attach(2); 
     myservoSLIDER.attach(3);
     
     myservoPUSHER.write(30);
     wait5seconds(); 
     myservoSLIDER.write(130);
     wait5seconds(); 
     myservoPUSHER.write(140);
     wait5seconds(); 
     myservoPUSHER.write(90);
     wait5seconds();   
     myservoSLIDER.write(90);
     wait5seconds(); 
      
     
     myservoPUSHER.detach();      
     myservoSLIDER.detach();
     
     OneHourCounter++;   
  } 


// if 5 minutes has passed move minute ball 5 minutes forward
  

  if (FiveMinuteCounter == 0)
  {
     myservoPUSHER.attach(2); 
     myservoSLIDER.attach(3);
     
     myservoPUSHER.write(30);
     wait5seconds(); 
     myservoSLIDER.write(130);
     wait5seconds();  
     myservoPUSHER.write(140);
     wait5seconds(); 
     myservoPUSHER.write(90);
     wait5seconds();  
     myservoSLIDER.write(90);
     wait5seconds(); 
      
     
     myservoPUSHER.detach();      
     myservoSLIDER.detach();
     
     OneHourCounter++;
  }


  // if minute ball has moved 12 times move hour ball 1 hour forward
  
  if (OneHourCounter >= 12)
  {
     myservoPUSHER.attach(2); 
     myservoSLIDER.attach(3);

     myservoPUSHER.write(65);
     wait5seconds(); 
     myservoSLIDER.write(50);
     wait5seconds();  
     myservoPUSHER.write(130);
     wait5seconds();  
     myservoSLIDER.write(90);
     wait5seconds(); 
     myservoPUSHER.write(90);
     wait5seconds(); 
      
     myservoPUSHER.detach();      
     myservoSLIDER.detach();  
   
     OneHourCounter = 0;   
  }
}

void wait5seconds()
{
   time_now = millis();
   while(millis() < time_now + 500)
   {
        //wait approx. 500 ms
   }
}
